#! /bin/sh
# $Id: pgsGen.sh.in,v 1.2 2002/05/08 15:01:03 waite Exp $
# Copyright (c) 1990, The Regents of the University of Colorado

# EXEC (pgsGen.sh) (.) (:Pgram) (:BuPgram) (+monitor)
#   NEEDS (eingabe.exe) (analyse.exe) (pgs_optim.exe) (buildtab.exe)
#         (StructConn) (parser.c) (pgs.dapto)
#   => (:pgsGen);

PKG=$1;shift; ODIN_Pgram=$1;shift; ODIN_BuPgram=$1;shift;
ODIN_monitor=$1;shift;
mkdir pgsGen;

SED=$ODINCACHE/PKGS/skeleton/sed.exe

if test '' = "$ODIN_monitor"
then echo 'AOUZ' > Optionen
else echo 'ACOUZ' > Optionen
fi

if test -s $ODIN_BuPgram
then
	input=$ODIN_BuPgram
	cp $ODIN_BuPgram Eindat
else
	input=$ODIN_Pgram
	cp $ODIN_Pgram Eindat
fi

(echo `cat Optionen`; echo $ODIN_CURDIR) | $PKG/eingabe.exe

$SED -e '/^#$/d
	/\* Error/s;^ *\([0-9]*\).*\*;'"$input"' 0 0;' Fehlerda \
	> ERRORS
if test -s ERRORS
then exit 0
fi

touch infile; cp /dev/null infile
 
if test "`$PKG/analyse.exe`" != ''
then
	if test -s $ODIN_BuPgram
	then
		# Check to see if the non-bottomup version is also not LALR(1)
		rm Eindat
		cp $ODIN_Pgram Eindat

		(echo `cat Optionen`; echo $ODIN_CURDIR) | \
			$PKG/eingabe.exe
		if test "`$PKG/analyse.exe`" != ''
		then
			echo "$input 0 0 Grammar is not LALR(1)" >> ERRORS
		else
			echo ". 0 0 You have bottomup constraints in your attribute grammar that cause your concrete syntax to not be parsable." >> ERRORS
		fi
	else echo "$input 0 0 Grammar is not LALR(1)" >> ERRORS
	fi
	exit 0
fi

mv Produdat Produein
mv Varanada Interdat

cat Optionen | \
	($PKG/pgs_optim.exe || echo 'Optimization failed') \
	>> ERRORS
if test -s ERRORS
then
        if test -s Putout; then cat Putout >> ERRORS; fi
        exit 0
fi

$PKG/buildtab.exe Zerdat pgs.mak.table Zudat

cat Zudat pgs.mak.table | $SED -e '/&MACRO/d' > pgsGen/pgs_gen.h
cat $PKG/StructConn Strukdat > pgsGen/pgs_gen.c
echo "}" >> pgsGen/pgs_gen.c
echo $PKG/parser.c > pgsGen/pgs.reqmod

if true
then
  if test '' != "$ODIN_monitor"
  then
	cp $PKG/pgs.dapto pgsGen/pgs.dapto
	echo $ODINCACHE/PKGS/parser/mon_cprods.c >> pgsGen/pgs.reqmod
	cp mon_cprods.h pgsGen/mon_cprods.h
  fi
fi
